/***

Copyright 2011-2012 Carlos Moreno Muoz

This file is part of Vands.

Vands is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Foobar is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
****/

function dibujar_fondo(){
    contexto.drawImage(escenario.fondo_img, 0, 0, ANCHURA_VENTANA, ALTURA_VENTANA); //pintamos el fondo del escenario	
}

function dibujar_rastro(){
	
	if(jugador.getX()!=ruta.getX() || jugador.getY()!=ruta.getY() || jugador.rastro_alpha<1.0){ //Se est moviendo o la nube no ha terminado de desaparecer
	
		jugador.rastro_alpha-=0.01;
		if(jugador.rastro_alpha<=0){
			jugador.xrastro=jugador.getX()-12;
			jugador.yrastro=jugador.getY()-25;
			
			jugador.rastro_alpha=1.0;
		}

		if((jugador.getX()!=ruta.getX() || jugador.getY()!=ruta.getY()) || jugador.rastro_alpha<1.0){
			contexto.globalAlpha = jugador.rastro_alpha;
			contexto.drawImage(jugador.rastro_img, jugador.xrastro, jugador.yrastro, jugador.rastro_tam, jugador.rastro_tam); //pintamos el fondo del escenario
		}
		
		contexto.globalAlpha = 1.0; //restauramos el valor de la opacidad
	}
}

function dibujar_depurar(){

	//Mostramos las areas de movimiento
	var i;
	contexto.strokeStyle = '#99F'; // Color
	
	//Eje X	
	for(i=0;i<escenario.area.length-1;i++){
		contexto.beginPath();
		contexto.moveTo(escenario.area[i][0],escenario.area[i][1]);
		contexto.lineTo(escenario.area[i+1][0],escenario.area[i][1]);
		contexto.closePath();
		contexto.stroke();
	}
	
	contexto.strokeStyle = '#F99'; // Color
	
	//Eje y	
	for(i=0;i<escenario.area.length;i++){
		contexto.beginPath();
		contexto.moveTo(escenario.area[i][0],escenario.area[i][1]);
		contexto.lineTo(escenario.area[i][0],ALTURA_VENTANA);
		contexto.closePath();
		contexto.stroke();
	}
	
	//Mostramos el borde de la imagen del personaje
	
	contexto.strokeStyle = '#9F9'; // Color
	
	contexto.beginPath();
	contexto.rect(posX, posY, jugador.cuerpo_width, jugador.cuerpo_height);
	contexto.closePath();
	contexto.stroke();
	
	//Mostramos la trayectria del personaje
	
	contexto.strokeStyle = '#FF9'; // Color
	contexto.beginPath();
	contexto.moveTo(jugador.getX(),jugador.getY());
	contexto.lineTo(ruta.getX(),ruta.getY());
	contexto.closePath();
	contexto.stroke();
	
	for(i=ruta.n_control;i<ruta.xcontrol.length-1;i++){
		contexto.beginPath();
		contexto.moveTo(ruta.xcontrol[i],ruta.ycontrol[i]);
		contexto.lineTo(ruta.xcontrol[i+1],ruta.ycontrol[i+1]);
		contexto.closePath();
		contexto.stroke();
	}
	
	//Mostramos el borde de los objetos	
	
	contexto.strokeStyle = '#9FF'; // Color
	for(i=0;i<escenario.objetos.length;i++){	
		contexto.beginPath();
		contexto.rect(escenario.objetos[i].x, escenario.objetos[i].y, escenario.objetos[i].width, escenario.objetos[i].height);
		contexto.closePath();
		contexto.stroke();
	}
	
	//Mostramos el area del personaje
	document.formulario.texto_area.value = "area: "+area_actual;
	//Mostramos las coordenadas actuales del personaje
	document.formulario.texto_xpos.value = "xpos: "+jugador.getX();
	document.formulario.texto_ypos.value = "ypos: "+jugador.getY();
	//Mostramos las coordenadas destino del personaje
	document.formulario.texto_xdest.value = "xdest: "+ruta.getX();
	document.formulario.texto_ydest.value = "ydest: "+ruta.getY();
}

function dibujar_jugador(){
	contexto.drawImage(jugador.cuerpo_img[fotograma], posX, posY,jugador.cuerpo_width,jugador.cuerpo_height);
	contexto.drawImage(jugador.cara_img, jugador.getXCara(),jugador.getYCara(),jugador.getCaraWidth(),jugador.getCaraHeight());
}

function dibujar_objetos(){
	var i;

	for(i=0;i<escenario.objetos.length;i++){
		if(i==objeto_destacado)
			contexto.drawImage(escenario.objetos[i].objeto_img[1], escenario.objetos[i].x, escenario.objetos[i].y, escenario.objetos[i].width, escenario.objetos[i].height);	
		else
			contexto.drawImage(escenario.objetos[i].objeto_img[0], escenario.objetos[i].x, escenario.objetos[i].y, escenario.objetos[i].width, escenario.objetos[i].height);	
	}
}

function dibujar_bocadillos(){
    var i;
    for(i=0;i<bocadillos.length;i++){
        if(bocadillos[i].estado==ABRIR_BOCADILLO){
            fadein_bocadillo(bocadillos[i]);
        }else if(bocadillos[i].estado==CERRAR_BOCADILLO){
            fadeout_bocadillo(bocadillos[i]);
        }
    }
        
}

function fadein_bocadillo(bocadillo){
	
        if(bocadillo.bocadillo_alpha<1.0){
                bocadillo.bocadillo_alpha+=0.01;
        }
            
        dibujar_bocadillo(bocadillo);
	
        contexto.globalAlpha = 1.0; //restauramos el valor de la opacidad
}

function fadeout_bocadillo(bocadillo){
    if(bocadillo.bocadillo_alpha>0){
            bocadillo.bocadillo_alpha-=0.01;
            if(bocadillo.bocadillo_alpha<=0.0)
                bocadillo.bocadillo_alpha=0.0;
            
            dibujar_bocadillo(bocadillo);
            
        }else{
            bocadillo.estado=0;
        }
        
    contexto.globalAlpha = 1.0; //restauramos el valor de la opacidad
}

function dibujar_bocadillo(bocadillo){    

    contexto.globalAlpha = bocadillo.bocadillo_alpha;
    contexto.drawImage(bocadillo.bocadillo_img, bocadillo.x, bocadillo.y, bocadillo.width, bocadillo.height);	
    contexto.fillStyle = "#000000"; // Color del texto
    //contexto.textBaseline = "top"; // Lnea base del texto
    contexto.font = "bold 18px Comic Sans"; // Tamao y estilo de la fuente
    contexto.fillText(bocadillo.texto, bocadillo.x+bocadillo.width/3, bocadillo.y+bocadillo.height/3); // Pintamos el texto.
    if(cerrar_destacado==bocadillo.id)
            contexto.drawImage(bocadillo.cerrar_img[1], bocadillo.cerrar_x, bocadillo.cerrar_y, bocadillo.cerrar_width, bocadillo.cerrar_height); //Pintamos el botn de cerrar
    else
            contexto.drawImage(bocadillo.cerrar_img[0], bocadillo.cerrar_x, bocadillo.cerrar_y, bocadillo.cerrar_width, bocadillo.cerrar_height); //Pintamos el botn de cerrar
}

function dibujar_menu(){
    
    if(menu.estado==DESPLEGAR_MENU){        
        
        if(menu.y<25)   menu.y++;
        var x=menu.x;
        
        var i;
        for(i=0;i<menu.botones.length;i++){
            contexto.drawImage(menu.botones[i].image, x, menu.y, menu.width, menu.height);        
            x+=menu.width+menu.ancho_margen;
        }
    }else if(menu.estado==REPLEGAR_MENU){
        if(menu.y>0){
            menu.y--;
            var x=menu.x;
            
            var i;
            for(i=0;i<menu.botones.length;i++){
                contexto.drawImage(menu.botones[i].image, x, menu.y, menu.width, menu.height);        
                x+=menu.width+menu.ancho_margen;       
            }
        }else{
            menu.estado=MENU_INACTIVO;
        }
    }
}